﻿<?php
// donate_log plugin for xaseco
// plugin logs coppers donations to file
// (c) schmidi 2009
// www.doh-nuts.at

// README
//
// Installation
// 	1) copy plugin.donate_log.php to plugin directory
// 	2) Insert <plugin>plugin.donate_log.php</plugin> into "plugins.xml"
//     ATTENTION: plugin.donate_log.php must be included before plugin.donate.php
//
// Usage
//  /donlog ON/OFF
//  /donlog list


// Release Notes
// 	v0.2
//	 added list, thx to jou for suggestion/code snippets
//	 reworked code
//  v0.1
//   initial release
//   thx to Xymph for code snippets


global $DON_LOG;
$DON_LOG['enabled'] = true;
$DON_LOG['filename'] = 'donate_log.txt';
$DON_LOG['list_by_user'] = false;


// #######################################################################################

Aseco::registerEvent('onBillUpdated', 'donate_log_onBillUpdated');
Aseco::addChatCommand('donlog', 'list {list}, enable {ON/OFF}');


// chat_donlog
// set DonationsLogging ON/OFF
// list latest donations
function chat_donlog($aseco, $command) {
	global $DON_LOG;

	$admin = $command['author'];
	$param = strtolower($command['params']);
	
	// list by user
 	if ($param == 'list' && $DON_LOG['list_by_user'] == true) {
		donate_log_list($aseco, $admin->login);
		return;
	}
		
	// masteradmin only
	if (!$aseco->isMasterAdmin($admin) || ($aseco->settings['lock_password'] != '' && !$admin->unlocked)) {
		// write warning in console
		$aseco->console($admin->login . ' tried to use admin chat command (no permission!): /donlog');
		// show chat message
		$message = $aseco->getChatMessage('NO_ADMIN');
		$aseco->addCall('ChatSendToLogin', array($aseco->formatColors($message), $admin->login));
		return false;
	}
	
	
	if ($param == 'on' || $param == 'off') {
		$DON_LOG['enabled'] = ($param == 'on');

		// log console message
		$aseco->console('{1} [{2}] set DonationLogging {3} !', 'MasterAdmin', $admin->nickname,	
			($DON_LOG['enabled'] ? 'ON' : 'OFF'));

		// show chat message
		$message = formatText('{#server}> {#admin}{1}$z$s {#highlite}{2}$z$s{#admin} set DonationLogging {3}',
			$aseco->titles['MASTERADMIN'][0], $admin->nickname, ($DON_LOG['enabled'] ? 'ON' : 'OFF'));
		$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $admin->login);
	}
	else if ($param == 'list') {
		donate_log_list($aseco, $admin->login);
	}
}

// list latest donations in ml-window
function donate_log_list($aseco, $login) {
	global $DON_LOG;

	if ($file = fopen($DON_LOG['filename'], 'r')) {
		// read log (latest entries)
		$log = array();
		while (!feof($file)) {
    	array_unshift($log, fgets($file, 100));
    	unset($log[17]);
		}
		fclose($file);
		
		// strip colors, prepare data
		foreach($log as &$l) {
			$txt = stripColors($l);
			if (strlen($txt)) {
				$data[] = array($txt);
			}
		}

    // display ml
		$header = '{#welcome}Latest Donations';
		display_manialink($login, $header, array('Icons64x64_1', 'IconPlayers', -0.01), $data, array(1), 'OK');

	}
	else {
		$aseco->console('donate_log: file open failed'); 

		// show chat message
		$message = formatText('{#server}> failed to open {1}', $DON_LOG['filename']);
		$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $admin->login);
	}
}


// called @ onBillUpdated
// [0]=BillId, [1]=State, [2]=StateName, [3]=TransactionId
function donate_log_onBillUpdated($aseco, $bill) {
	global $bills;
	global $DON_LOG;

  if (!$DON_LOG['enabled']) return;
  
	$billid = $bill[0];
	// check for known bill ID
	if (array_key_exists($billid, $bills)) {
		// get bill info
		$login = $bills[$billid][0];
		$nickname = $bills[$billid][1];
		$coppers = $bills[$billid][2];

		// player donated coppers
		if ($bill[1] == 4) {
			$text = '[' . date('m/d,H:i:s') . '] ';
			
			if ($coppers > 0) {
				$text .= $coppers . ' coppers donated by ' . $login . ' ('.$nickname.')' . CRLF;
			} 
			else {
				$text .= abs($coppers) . ' coppers payed by ' . $login . ' to ' . $nickname . CRLF;
			}
			
			if ($file = fopen($DON_LOG['filename'], 'a+')) {
				fwrite($file, $text);
				fclose($file);
			}
			else {
				$aseco->console('donate_log: file open failed'); 
			}
		}
	}
	else {
		$aseco->console('donate_log: Read the README and check your plugins.xml.'); 
	}
}

?>
